# coding: utf-8

from utg.relations import *
from utg import data
from utg import logic

# receive and return only serialized data
def migrate(word_data):
    word_type = WORD_TYPE(word_data['type'])
    return migrate_forms(word_data, OLD_CACHES[word_type], data.WORDS_CACHES[word_type])


def migrate_forms(word_data, old_cache, new_cache):
    old_forms = word_data['forms']
    new_forms = [''] * len(new_cache)

    for new_key, new_index in new_cache.items():
        new_forms[new_index] = old_forms[get_nearest_old_index(new_key, old_cache)]

    word_data['forms'] = new_forms

    return word_data


def get_nearest_old_index(new_key, old_cache):
    old_key = logic.get_nearest_key(new_key, list(old_cache.keys()))
    return old_cache[old_key]


OLD_CACHES = {WORD_TYPE.NOUN: {(NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.NOMINATIVE): 0,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.GENITIVE): 1,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.DATIVE): 2,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.ACCUSATIVE): 3,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.INSTRUMENTAL): 4,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.PREPOSITIONAL): 5,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.NOMINATIVE): 6,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.GENITIVE): 7,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.DATIVE): 8,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.ACCUSATIVE): 9,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.INSTRUMENTAL): 10,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.PREPOSITIONAL): 11,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.NOMINATIVE): 12,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.GENITIVE): 13,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.DATIVE): 14,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.ACCUSATIVE): 15,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.INSTRUMENTAL): 16,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.PREPOSITIONAL): 17},
 WORD_TYPE.ADJECTIVE: {(ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.POSITIVE): 0,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 1,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 2,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.POSITIVE): 3,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 4,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 5,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.POSITIVE): 6,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 7,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 8,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.POSITIVE): 9,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 10,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 11,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.POSITIVE): 12,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 13,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 14,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.POSITIVE): 15,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 16,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 17,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.POSITIVE): 18,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 19,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 20,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.POSITIVE): 21,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 22,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 23,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.POSITIVE): 24,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 25,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 26,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.POSITIVE): 27,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 28,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 29,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.POSITIVE): 30,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 31,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 32,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.POSITIVE): 33,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 34,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 35,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.POSITIVE): 36,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 37,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 38,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.POSITIVE): 39,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 40,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 41,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.POSITIVE): 42,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 43,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 44,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.POSITIVE): 45,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 46,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 47,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.POSITIVE): 48,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 49,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 50,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.POSITIVE): 51,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 52,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 53,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.POSITIVE): 54,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 55,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 56,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.POSITIVE): 57,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 58,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 59,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.POSITIVE): 60,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 61,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 62,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.POSITIVE): 63,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 64,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 65,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.POSITIVE): 66,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 67,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 68,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.POSITIVE): 69,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 70,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 71,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.POSITIVE): 72,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 73,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 74,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.POSITIVE): 75,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 76,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 77,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.POSITIVE): 78,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 79,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 80,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.POSITIVE): 81,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 82,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 83,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.POSITIVE): 84,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 85,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 86,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.POSITIVE): 87,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 88,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 89,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.POSITIVE): 90,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 91,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 92,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.POSITIVE): 93,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 94,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 95,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.POSITIVE): 96,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 97,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 98,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.POSITIVE): 99,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 100,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 101,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.POSITIVE): 102,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 103,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 104,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.POSITIVE): 105,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 106,
                       (ADJECTIVE_FORM.FULL, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 107,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE, GRADE.POSITIVE): 108,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 109,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 110,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE, GRADE.POSITIVE): 111,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 112,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 113,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE, GRADE.POSITIVE): 114,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 115,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 116,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE, GRADE.POSITIVE): 117,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 118,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 119,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE, GRADE.POSITIVE): 120,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 121,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 122,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE, GRADE.POSITIVE): 123,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 124,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 125,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE, GRADE.POSITIVE): 126,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 127,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 128,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE, GRADE.POSITIVE): 129,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 130,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 131,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE, GRADE.POSITIVE): 132,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 133,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 134,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE, GRADE.POSITIVE): 135,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 136,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 137,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE, GRADE.POSITIVE): 138,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE, GRADE.COMPARATIVE): 139,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE, GRADE.SUPERLATIVE): 140,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE, GRADE.POSITIVE): 141,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE, GRADE.COMPARATIVE): 142,
                       (ADJECTIVE_FORM.FULL, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE, GRADE.SUPERLATIVE): 143,
                       (ADJECTIVE_FORM.SHORT, NUMBER.SINGULAR, None, GENDER.MASCULINE, None, None): 144,
                       (ADJECTIVE_FORM.SHORT, NUMBER.SINGULAR, None, GENDER.NEUTER, None, None): 145,
                       (ADJECTIVE_FORM.SHORT, NUMBER.SINGULAR, None, GENDER.FEMININE, None, None): 146,
                       (ADJECTIVE_FORM.SHORT, NUMBER.PLURAL, None, None, None, None): 147},
 WORD_TYPE.PRONOUN: {(NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.FIRST, GENDER.MASCULINE): 0,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.FIRST, GENDER.NEUTER): 1,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.FIRST, GENDER.FEMININE): 2,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.SECOND, GENDER.MASCULINE): 3,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.SECOND, GENDER.NEUTER): 4,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.SECOND, GENDER.FEMININE): 5,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.THIRD, GENDER.MASCULINE): 6,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.THIRD, GENDER.NEUTER): 7,
                     (NUMBER.SINGULAR, CASE.NOMINATIVE, PERSON.THIRD, GENDER.FEMININE): 8,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.FIRST, GENDER.MASCULINE): 9,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.FIRST, GENDER.NEUTER): 10,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.FIRST, GENDER.FEMININE): 11,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.SECOND, GENDER.MASCULINE): 12,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.SECOND, GENDER.NEUTER): 13,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.SECOND, GENDER.FEMININE): 14,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.THIRD, GENDER.MASCULINE): 15,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.THIRD, GENDER.NEUTER): 16,
                     (NUMBER.SINGULAR, CASE.GENITIVE, PERSON.THIRD, GENDER.FEMININE): 17,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.FIRST, GENDER.MASCULINE): 18,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.FIRST, GENDER.NEUTER): 19,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.FIRST, GENDER.FEMININE): 20,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.SECOND, GENDER.MASCULINE): 21,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.SECOND, GENDER.NEUTER): 22,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.SECOND, GENDER.FEMININE): 23,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.THIRD, GENDER.MASCULINE): 24,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.THIRD, GENDER.NEUTER): 25,
                     (NUMBER.SINGULAR, CASE.DATIVE, PERSON.THIRD, GENDER.FEMININE): 26,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.FIRST, GENDER.MASCULINE): 27,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.FIRST, GENDER.NEUTER): 28,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.FIRST, GENDER.FEMININE): 29,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.SECOND, GENDER.MASCULINE): 30,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.SECOND, GENDER.NEUTER): 31,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.SECOND, GENDER.FEMININE): 32,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.THIRD, GENDER.MASCULINE): 33,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.THIRD, GENDER.NEUTER): 34,
                     (NUMBER.SINGULAR, CASE.ACCUSATIVE, PERSON.THIRD, GENDER.FEMININE): 35,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.FIRST, GENDER.MASCULINE): 36,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.FIRST, GENDER.NEUTER): 37,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.FIRST, GENDER.FEMININE): 38,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.SECOND, GENDER.MASCULINE): 39,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.SECOND, GENDER.NEUTER): 40,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.SECOND, GENDER.FEMININE): 41,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.THIRD, GENDER.MASCULINE): 42,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.THIRD, GENDER.NEUTER): 43,
                     (NUMBER.SINGULAR, CASE.INSTRUMENTAL, PERSON.THIRD, GENDER.FEMININE): 44,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.FIRST, GENDER.MASCULINE): 45,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.FIRST, GENDER.NEUTER): 46,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.FIRST, GENDER.FEMININE): 47,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.SECOND, GENDER.MASCULINE): 48,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.SECOND, GENDER.NEUTER): 49,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.SECOND, GENDER.FEMININE): 50,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.THIRD, GENDER.MASCULINE): 51,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.THIRD, GENDER.NEUTER): 52,
                     (NUMBER.SINGULAR, CASE.PREPOSITIONAL, PERSON.THIRD, GENDER.FEMININE): 53,
                     (NUMBER.PLURAL, CASE.NOMINATIVE, PERSON.FIRST, None): 54,
                     (NUMBER.PLURAL, CASE.NOMINATIVE, PERSON.SECOND, None): 55,
                     (NUMBER.PLURAL, CASE.NOMINATIVE, PERSON.THIRD, None): 56,
                     (NUMBER.PLURAL, CASE.GENITIVE, PERSON.FIRST, None): 57,
                     (NUMBER.PLURAL, CASE.GENITIVE, PERSON.SECOND, None): 58,
                     (NUMBER.PLURAL, CASE.GENITIVE, PERSON.THIRD, None): 59,
                     (NUMBER.PLURAL, CASE.DATIVE, PERSON.FIRST, None): 60,
                     (NUMBER.PLURAL, CASE.DATIVE, PERSON.SECOND, None): 61,
                     (NUMBER.PLURAL, CASE.DATIVE, PERSON.THIRD, None): 62,
                     (NUMBER.PLURAL, CASE.ACCUSATIVE, PERSON.FIRST, None): 63,
                     (NUMBER.PLURAL, CASE.ACCUSATIVE, PERSON.SECOND, None): 64,
                     (NUMBER.PLURAL, CASE.ACCUSATIVE, PERSON.THIRD, None): 65,
                     (NUMBER.PLURAL, CASE.INSTRUMENTAL, PERSON.FIRST, None): 66,
                     (NUMBER.PLURAL, CASE.INSTRUMENTAL, PERSON.SECOND, None): 67,
                     (NUMBER.PLURAL, CASE.INSTRUMENTAL, PERSON.THIRD, None): 68,
                     (NUMBER.PLURAL, CASE.PREPOSITIONAL, PERSON.FIRST, None): 69,
                     (NUMBER.PLURAL, CASE.PREPOSITIONAL, PERSON.SECOND, None): 70,
                     (NUMBER.PLURAL, CASE.PREPOSITIONAL, PERSON.THIRD, None): 71},
 WORD_TYPE.VERB: {(VERB_FORM.INFINITIVE, None, None, None, None): 0,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.MASCULINE): 1,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.NEUTER): 2,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.FEMININE): 3,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.PLURAL, None, None): 4,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.FIRST, None): 5,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.SECOND, None): 6,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.THIRD, None): 7,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.FIRST, None): 8,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.SECOND, None): 9,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.THIRD, None): 10,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.FIRST, None): 11,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.SECOND, None): 12,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.THIRD, None): 13,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.FIRST, None): 14,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.SECOND, None): 15,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.THIRD, None): 16,
                  (VERB_FORM.CONDITIONAL, None, NUMBER.SINGULAR, None, GENDER.MASCULINE): 17,
                  (VERB_FORM.CONDITIONAL, None, NUMBER.SINGULAR, None, GENDER.NEUTER): 18,
                  (VERB_FORM.CONDITIONAL, None, NUMBER.SINGULAR, None, GENDER.FEMININE): 19,
                  (VERB_FORM.CONDITIONAL, None, NUMBER.PLURAL, None, None): 20,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.SINGULAR, PERSON.FIRST, None): 21,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.SINGULAR, PERSON.SECOND, None): 22,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.SINGULAR, PERSON.THIRD, None): 23,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.PLURAL, PERSON.FIRST, None): 24,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.PLURAL, PERSON.SECOND, None): 25,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.PLURAL, PERSON.THIRD, None): 26},
 WORD_TYPE.PARTICIPLE: {(PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 0,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 1,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 2,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 3,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 4,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 5,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 6,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 7,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 8,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 9,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 10,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 11,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 12,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 13,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 14,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 15,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 16,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 17,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 18,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 19,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 20,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 21,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 22,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 23,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 24,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 25,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 26,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 27,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 28,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 29,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 30,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 31,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 32,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 33,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 34,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 35,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 36,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 37,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 38,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 39,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 40,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 41,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 42,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 43,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 44,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 45,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 46,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.DIRECT, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 47,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 48,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 49,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 50,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 51,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 52,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 53,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 54,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 55,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 56,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 57,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 58,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 59,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 60,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 61,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 62,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 63,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 64,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 65,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.ANIMATE): 66,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE, ANIMALITY.INANIMATE): 67,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.ANIMATE): 68,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER, ANIMALITY.INANIMATE): 69,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.ANIMATE): 70,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE, ANIMALITY.INANIMATE): 71,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 72,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 73,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 74,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 75,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 76,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 77,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.ANIMATE): 78,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE, ANIMALITY.INANIMATE): 79,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.ANIMATE): 80,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER, ANIMALITY.INANIMATE): 81,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.ANIMATE): 82,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE, ANIMALITY.INANIMATE): 83,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 84,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 85,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 86,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 87,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 88,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 89,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 90,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 91,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 92,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 93,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 94,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, VOICE.REVERSE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 95,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.SINGULAR, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 96,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.SINGULAR, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 97,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.SINGULAR, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 98,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.SINGULAR, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 99,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.SINGULAR, CASE.DATIVE, None, ANIMALITY.ANIMATE): 100,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.SINGULAR, CASE.DATIVE, None, ANIMALITY.INANIMATE): 101,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.SINGULAR, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 102,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.SINGULAR, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 103,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 104,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 105,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 106,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 107,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 108,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 109,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 110,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 111,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 112,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 113,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 114,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 115,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 116,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 117,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 118,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.DIRECT, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 119,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.SINGULAR, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 120,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.SINGULAR, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 121,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.SINGULAR, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 122,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.SINGULAR, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 123,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.SINGULAR, CASE.DATIVE, None, ANIMALITY.ANIMATE): 124,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.SINGULAR, CASE.DATIVE, None, ANIMALITY.INANIMATE): 125,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.SINGULAR, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 126,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.SINGULAR, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 127,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 128,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 129,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 130,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 131,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 132,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 133,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 134,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 135,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 136,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 137,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 138,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 139,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 140,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 141,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 142,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, VOICE.REVERSE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 143,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.SINGULAR, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 144,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.SINGULAR, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 145,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.SINGULAR, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 146,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.SINGULAR, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 147,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.SINGULAR, CASE.DATIVE, None, ANIMALITY.ANIMATE): 148,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.SINGULAR, CASE.DATIVE, None, ANIMALITY.INANIMATE): 149,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.SINGULAR, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 150,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.SINGULAR, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 151,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 152,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.SINGULAR, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 153,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 154,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.SINGULAR, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 155,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 156,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 157,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 158,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 159,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 160,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 161,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 162,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 163,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 164,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 165,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 166,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.DIRECT, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 167,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.SINGULAR, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 168,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.SINGULAR, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 169,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.SINGULAR, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 170,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.SINGULAR, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 171,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.SINGULAR, CASE.DATIVE, None, ANIMALITY.ANIMATE): 172,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.SINGULAR, CASE.DATIVE, None, ANIMALITY.INANIMATE): 173,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.SINGULAR, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 174,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.SINGULAR, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 175,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 176,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 177,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 178,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 179,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.ANIMATE): 180,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.PLURAL, CASE.NOMINATIVE, None, ANIMALITY.INANIMATE): 181,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.ANIMATE): 182,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.PLURAL, CASE.GENITIVE, None, ANIMALITY.INANIMATE): 183,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.ANIMATE): 184,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.PLURAL, CASE.DATIVE, None, ANIMALITY.INANIMATE): 185,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.ANIMATE): 186,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.PLURAL, CASE.ACCUSATIVE, None, ANIMALITY.INANIMATE): 187,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.ANIMATE): 188,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None, ANIMALITY.INANIMATE): 189,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.ANIMATE): 190,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, VOICE.REVERSE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None, ANIMALITY.INANIMATE): 191,
                        (PARTICIPLE_FORM.SHORT, None, None, NUMBER.SINGULAR, None, GENDER.MASCULINE, None): 192,
                        (PARTICIPLE_FORM.SHORT, None, None, NUMBER.SINGULAR, None, GENDER.NEUTER, None): 193,
                        (PARTICIPLE_FORM.SHORT, None, None, NUMBER.SINGULAR, None, GENDER.FEMININE, None): 194,
                        (PARTICIPLE_FORM.SHORT, None, None, NUMBER.PLURAL, None, None, None): 195},
 WORD_TYPE.INTEGER: {(): 0},
 WORD_TYPE.TEXT: {(): 0},
 WORD_TYPE.PREPOSITION: {(PREPOSITION_FORM.NORMAL,): 0,
                         (PREPOSITION_FORM.ALTERNATIVE,): 1,
                         (PREPOSITION_FORM.SPECIAL,): 2}}
