# coding: utf-8

from utg.relations import *
from utg import logic

# receive and return only serialized data
def migrate(word_data):
    word_type = WORD_TYPE(word_data['type'])
    return migrate_forms(word_data, OLD_CACHES[word_type], NEW_CACHES[word_type])


def migrate_forms(word_data, old_cache, new_cache):
    old_forms = word_data['forms']
    new_forms = [''] * len(new_cache)

    for new_key, new_index in new_cache.items():
        new_forms[new_index] = old_forms[get_nearest_old_index(new_key, old_cache)]

    word_data['forms'] = new_forms

    return word_data


def get_nearest_old_index(new_key, old_cache):
    old_key = logic.get_nearest_key(new_key, list(old_cache.keys()))
    return old_cache[old_key]

OLD_CACHES = {WORD_TYPE.NOUN: {(NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.NOMINATIVE): 0,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.GENITIVE): 1,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.DATIVE): 2,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.ACCUSATIVE): 3,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.INSTRUMENTAL): 4,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.PREPOSITIONAL): 5,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.NOMINATIVE): 6,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.GENITIVE): 7,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.DATIVE): 8,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.ACCUSATIVE): 9,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.INSTRUMENTAL): 10,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.PREPOSITIONAL): 11,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.NOMINATIVE): 12,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.GENITIVE): 13,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.DATIVE): 14,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.ACCUSATIVE): 15,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.INSTRUMENTAL): 16,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.PREPOSITIONAL): 17},
 WORD_TYPE.ADJECTIVE: {(ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 0,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 1,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 2,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 3,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 4,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 5,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 6,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 7,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 8,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 9,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 10,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 11,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 12,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 13,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 14,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 15,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 16,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 17,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 18,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 19,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 20,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 21,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 22,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 23,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 24,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 25,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 26,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 27,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 28,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 29,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 30,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 31,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 32,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 33,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 34,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 35,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 36,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 37,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 38,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 39,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 40,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 41,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 42,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 43,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 44,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 45,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 46,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 47,
                       (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, None, None, None, None): 48,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 49,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 50,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 51,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 52,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 53,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 54,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 55,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 56,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 57,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 58,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 59,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 60,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 61,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 62,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 63,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 64,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 65,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 66,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 67,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 68,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 69,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 70,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 71,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 72,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 73,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 74,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 75,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 76,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 77,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 78,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 79,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 80,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 81,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 82,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 83,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 84,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 85,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 86,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 87,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 88,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 89,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 90,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 91,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 92,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 93,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 94,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 95,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 96,
                       (ADJECTIVE_FORM.SHORT, None, None, NUMBER.SINGULAR, None, GENDER.MASCULINE): 97,
                       (ADJECTIVE_FORM.SHORT, None, None, NUMBER.SINGULAR, None, GENDER.NEUTER): 98,
                       (ADJECTIVE_FORM.SHORT, None, None, NUMBER.SINGULAR, None, GENDER.FEMININE): 99,
                       (ADJECTIVE_FORM.SHORT, None, None, NUMBER.PLURAL, None, None): 100},
 WORD_TYPE.PRONOUN: {(None, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 6,
 (None, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 7,
 (None, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 8,
 (None, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 15,
 (None, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 16,
 (None, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 17,
 (None, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 24,
 (None, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 25,
 (None, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 26,
 (None, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 33,
 (None, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 34,
 (None, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 35,
 (None, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 42,
 (None, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 43,
 (None, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 44,
 (None, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 51,
 (None, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 52,
 (None, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 53,
 (None, NUMBER.PLURAL, CASE.NOMINATIVE, None): 56,
 (None, NUMBER.PLURAL, CASE.GENITIVE, None): 59,
 (None, NUMBER.PLURAL, CASE.DATIVE, None): 62,
 (None, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 65,
 (None, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 68,
 (None, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 71},
 WORD_TYPE.VERB: {(VERB_FORM.INFINITIVE, None, None, None, None): 0,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.MASCULINE): 1,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.NEUTER): 2,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.FEMININE): 3,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.PLURAL, None, None): 4,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.FIRST, None): 5,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.SECOND, None): 6,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.THIRD, None): 7,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.FIRST, None): 8,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.SECOND, None): 9,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.THIRD, None): 10,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.FIRST, None): 11,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.SECOND, None): 12,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.THIRD, None): 13,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.FIRST, None): 14,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.SECOND, None): 15,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.THIRD, None): 16,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.SINGULAR, PERSON.SECOND, None): 17,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.PLURAL, PERSON.FIRST, None): 18,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.PLURAL, PERSON.SECOND, None): 19},
 WORD_TYPE.PARTICIPLE: {(PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 0,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 1,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 2,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 3,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 4,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 5,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 6,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 7,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 8,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 9,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 10,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 11,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 12,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 13,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 14,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 15,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 16,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 17,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 18,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 19,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 20,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 21,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 22,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 23,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 24,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 25,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 26,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 27,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 28,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 29,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 30,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 31,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 32,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 33,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 34,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 35,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 36,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 37,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 38,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 39,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 40,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 41,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 42,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 43,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 44,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 45,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 46,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 47,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 48,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 49,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 50,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 51,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 52,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 53,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 54,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 55,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 56,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 57,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 58,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 59,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 60,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 61,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 62,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 63,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 64,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 65,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 66,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 67,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 68,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 69,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 70,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 71,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 72,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 73,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 74,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 75,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 76,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 77,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 78,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 79,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 80,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 81,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 82,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 83,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 84,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 85,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 86,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 87,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 88,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 89,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 90,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 91,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 92,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 93,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 94,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 95,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 96,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 97,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 98,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 99,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 100,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 101,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 102,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 103,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 104,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 105,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 106,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 107,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 108,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 109,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 110,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 111,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 112,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 113,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 114,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 115,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 116,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 117,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 118,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 119,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 120,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 121,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 122,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 123,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 124,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 125,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 126,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 127,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 128,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 129,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 130,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 131,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 132,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 133,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 134,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 135,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 136,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 137,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 138,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 139,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 140,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 141,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 142,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 143,
                        (PARTICIPLE_FORM.SHORT, None, None, NUMBER.SINGULAR, None, GENDER.MASCULINE): 144,
                        (PARTICIPLE_FORM.SHORT, None, None, NUMBER.SINGULAR, None, GENDER.NEUTER): 145,
                        (PARTICIPLE_FORM.SHORT, None, None, NUMBER.SINGULAR, None, GENDER.FEMININE): 146,
                        (PARTICIPLE_FORM.SHORT, None, None, NUMBER.PLURAL, None, None): 147},
 WORD_TYPE.INTEGER: {(): 0},
 WORD_TYPE.TEXT: {(): 0},
 WORD_TYPE.PREPOSITION: {(PREPOSITION_FORM.NORMAL,): 0,
                         (PREPOSITION_FORM.ALTERNATIVE,): 1,
                         (PREPOSITION_FORM.SPECIAL,): 2}}


NEW_CACHES = {WORD_TYPE.NOUN: {(NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.NOMINATIVE): 0,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.GENITIVE): 1,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.DATIVE): 2,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.ACCUSATIVE): 3,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.INSTRUMENTAL): 4,
                  (NOUN_FORM.NORMAL, NUMBER.SINGULAR, CASE.PREPOSITIONAL): 5,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.NOMINATIVE): 6,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.GENITIVE): 7,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.DATIVE): 8,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.ACCUSATIVE): 9,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.INSTRUMENTAL): 10,
                  (NOUN_FORM.NORMAL, NUMBER.PLURAL, CASE.PREPOSITIONAL): 11,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.NOMINATIVE): 12,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.GENITIVE): 13,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.DATIVE): 14,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.ACCUSATIVE): 15,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.INSTRUMENTAL): 16,
                  (NOUN_FORM.COUNTABLE, NUMBER.PLURAL, CASE.PREPOSITIONAL): 17},
 WORD_TYPE.ADJECTIVE: {(ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 0,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 1,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 2,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 3,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 4,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 5,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 6,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 7,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 8,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 9,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 10,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 11,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 12,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 13,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 14,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 15,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 16,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 17,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 18,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 19,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 20,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 21,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 22,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 23,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 24,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 25,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 26,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 27,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 28,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 29,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 30,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 31,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 32,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 33,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 34,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 35,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 36,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 37,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 38,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 39,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 40,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 41,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 42,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 43,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 44,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 45,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 46,
                       (ADJECTIVE_FORM.FULL, GRADE.POSITIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 47,
                       (ADJECTIVE_FORM.FULL, GRADE.COMPARATIVE, None, None, None, None): 48,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 49,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 50,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 51,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 52,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 53,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 54,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 55,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 56,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 57,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 58,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 59,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 60,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 61,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 62,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 63,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 64,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 65,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 66,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 67,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 68,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 69,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 70,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 71,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 72,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 73,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 74,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 75,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 76,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 77,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 78,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 79,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 80,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 81,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 82,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 83,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 84,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 85,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 86,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 87,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 88,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 89,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 90,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 91,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 92,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 93,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 94,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 95,
                       (ADJECTIVE_FORM.FULL, GRADE.SUPERLATIVE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 96,
                       (ADJECTIVE_FORM.SHORT, None, None, NUMBER.SINGULAR, None, GENDER.MASCULINE): 97,
                       (ADJECTIVE_FORM.SHORT, None, None, NUMBER.SINGULAR, None, GENDER.NEUTER): 98,
                       (ADJECTIVE_FORM.SHORT, None, None, NUMBER.SINGULAR, None, GENDER.FEMININE): 99,
                       (ADJECTIVE_FORM.SHORT, None, None, NUMBER.PLURAL, None, None): 100},
 WORD_TYPE.PRONOUN: {(ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 0,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 1,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 2,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 3,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 4,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 5,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 6,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 7,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 8,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 9,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 10,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 11,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 12,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 13,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 14,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 15,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 16,
                     (ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 17,
                     (ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 18,
                     (ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 19,
                     (ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 20,
                     (ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 21,
                     (ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 22,
                     (ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 23,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 24,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 25,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 26,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 27,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 28,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 29,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 30,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 31,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 32,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 33,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 34,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 35,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 36,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 37,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 38,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 39,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 40,
                     (ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 41,
                     (ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 42,
                     (ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 43,
                     (ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 44,
                     (ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 45,
                     (ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 46,
                     (ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 47},
 WORD_TYPE.VERB: {(VERB_FORM.INFINITIVE, None, None, None, None): 0,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.MASCULINE): 1,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.NEUTER): 2,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.SINGULAR, None, GENDER.FEMININE): 3,
                  (VERB_FORM.INDICATIVE, TIME.PAST, NUMBER.PLURAL, None, None): 4,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.FIRST, None): 5,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.SECOND, None): 6,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.SINGULAR, PERSON.THIRD, None): 7,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.FIRST, None): 8,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.SECOND, None): 9,
                  (VERB_FORM.INDICATIVE, TIME.PRESENT, NUMBER.PLURAL, PERSON.THIRD, None): 10,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.FIRST, None): 11,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.SECOND, None): 12,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.SINGULAR, PERSON.THIRD, None): 13,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.FIRST, None): 14,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.SECOND, None): 15,
                  (VERB_FORM.INDICATIVE, TIME.FUTURE, NUMBER.PLURAL, PERSON.THIRD, None): 16,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.SINGULAR, PERSON.SECOND, None): 17,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.PLURAL, PERSON.FIRST, None): 18,
                  (VERB_FORM.IMPERATIVE, None, NUMBER.PLURAL, PERSON.SECOND, None): 19},
 WORD_TYPE.PARTICIPLE: {(PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 0,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 1,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 2,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 3,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 4,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 5,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 6,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 7,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 8,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 9,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 10,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 11,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 12,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 13,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 14,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 15,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 16,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 17,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 18,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 19,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 20,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 21,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 22,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 23,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 24,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 25,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 26,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 27,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 28,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 29,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 30,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 31,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 32,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 33,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 34,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 35,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 36,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 37,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 38,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 39,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 40,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 41,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 42,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 43,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 44,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 45,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 46,
                        (PARTICIPLE_FORM.FULL, TIME.PAST, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 47,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 48,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 49,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 50,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 51,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 52,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 53,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 54,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 55,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 56,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 57,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 58,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 59,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 60,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 61,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 62,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 63,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 64,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 65,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 66,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 67,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 68,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 69,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 70,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 71,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 72,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 73,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 74,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 75,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 76,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 77,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 78,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 79,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 80,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 81,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 82,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 83,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 84,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 85,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 86,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 87,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 88,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 89,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 90,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 91,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 92,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 93,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 94,
                        (PARTICIPLE_FORM.FULL, TIME.PRESENT, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 95,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 96,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 97,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 98,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 99,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 100,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 101,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 102,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 103,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 104,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 105,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 106,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 107,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 108,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 109,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 110,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 111,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 112,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 113,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 114,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 115,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 116,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 117,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 118,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.ANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 119,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.MASCULINE): 120,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.NEUTER): 121,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.NOMINATIVE, GENDER.FEMININE): 122,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.MASCULINE): 123,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.NEUTER): 124,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.GENITIVE, GENDER.FEMININE): 125,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.MASCULINE): 126,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.NEUTER): 127,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.DATIVE, GENDER.FEMININE): 128,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.MASCULINE): 129,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.NEUTER): 130,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.ACCUSATIVE, GENDER.FEMININE): 131,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.MASCULINE): 132,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.NEUTER): 133,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.INSTRUMENTAL, GENDER.FEMININE): 134,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.MASCULINE): 135,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.NEUTER): 136,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.SINGULAR, CASE.PREPOSITIONAL, GENDER.FEMININE): 137,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.NOMINATIVE, None): 138,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.GENITIVE, None): 139,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.DATIVE, None): 140,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.ACCUSATIVE, None): 141,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.INSTRUMENTAL, None): 142,
                        (PARTICIPLE_FORM.FULL, TIME.FUTURE, ANIMALITY.INANIMATE, NUMBER.PLURAL, CASE.PREPOSITIONAL, None): 143,
                        (PARTICIPLE_FORM.SHORT, None, None, NUMBER.SINGULAR, None, GENDER.MASCULINE): 144,
                        (PARTICIPLE_FORM.SHORT, None, None, NUMBER.SINGULAR, None, GENDER.NEUTER): 145,
                        (PARTICIPLE_FORM.SHORT, None, None, NUMBER.SINGULAR, None, GENDER.FEMININE): 146,
                        (PARTICIPLE_FORM.SHORT, None, None, NUMBER.PLURAL, None, None): 147},
 WORD_TYPE.INTEGER: {(): 0},
 WORD_TYPE.TEXT: {(): 0},
 WORD_TYPE.PREPOSITION: {(PREPOSITION_FORM.NORMAL,): 0,
                         (PREPOSITION_FORM.ALTERNATIVE,): 1,
                         (PREPOSITION_FORM.SPECIAL,): 2}}
